Index: gcc/testsuite/gfortran.dg/pr78719_3.f90
===================================================================
--- gcc/testsuite/gfortran.dg/pr78719_3.f90	(.../tags/gcc_9_2_0_release)	1970-01-01 01:00:00.000000000 +0100
+++ gcc/testsuite/gfortran.dg/pr78719_3.f90	(.../branches/gcc-9-branch)
@@ -0,0 +1,32 @@
+! { dg-do compile }
+! PR fortran/78719
+! Code contributed by Gerhard Steinmetz 
+program p
+
+   type t
+      integer :: n
+   end type
+
+   class(t) :: g     ! { dg-error "must be dummy, allocatable or pointer" }
+
+   abstract interface
+      subroutine h
+      end
+   end interface
+
+   procedure(h), pointer :: s
+
+   s => f
+   call s
+   s => g            ! { dg-error "Invalid procedure pointer" }
+   call s
+
+   contains
+
+      subroutine f
+      end
+
+      subroutine g   ! { dg-error "has an explicit interface" }
+      end
+
+end program p        ! { dg-error "Syntax error" }
Index: gcc/testsuite/gfortran.dg/typebound_call_22.f03
===================================================================
--- gcc/testsuite/gfortran.dg/typebound_call_22.f03	(.../tags/gcc_9_2_0_release)
+++ gcc/testsuite/gfortran.dg/typebound_call_22.f03	(.../branches/gcc-9-branch)
@@ -26,4 +26,4 @@
   call x%bar ()
 end program
 
-! { dg-final { scan-tree-dump-times "base \\(\\);" 1 "optimized" } }
+! { dg-final { scan-tree-dump-times "base \\(\\);" 1 "optimized" { xfail *-*-* } } }
Index: gcc/testsuite/gfortran.dg/use_rename_8.f90
===================================================================
--- gcc/testsuite/gfortran.dg/use_rename_8.f90	(.../tags/gcc_9_2_0_release)
+++ gcc/testsuite/gfortran.dg/use_rename_8.f90	(.../branches/gcc-9-branch)
@@ -19,8 +19,8 @@
     USE MOO, ONLY: X => B
 END SUBROUTINE T
 
-SUBROUTINE C
-    USE MOO, ONLY: C  ! { dg-error "is also the name of the current program unit" }
+SUBROUTINE C          ! { dg-error "\(1\)" }
+    USE MOO, ONLY: C  ! { dg-error "conflicts with the" }
 END SUBROUTINE C
 
 SUBROUTINE D
@@ -36,15 +36,15 @@
     USE MOO, ONLY: X => F
 END SUBROUTINE F
 
-SUBROUTINE X
-    USE MOO, ONLY: X => G ! { dg-error "is also the name of the current program unit" }
+SUBROUTINE X              ! { dg-error "\(1\)" }
+    USE MOO, ONLY: X => G ! { dg-error "conflicts with the rename" }
 END SUBROUTINE X
 
-SUBROUTINE Y
-    USE MOO, ONLY: Y => H ! { dg-error "is also the name of the current program unit" }
+SUBROUTINE Y              ! { dg-error "\(1\)" }
+    USE MOO, ONLY: Y => H ! { dg-error "conflicts with the rename" }
 END SUBROUTINE Y
 
-SUBROUTINE Z
-    USE MOO, ONLY: Z => I, Z => I ! { dg-error "is also the name of the current program unit" }
+SUBROUTINE Z                        ! { dg-error "\(1\)" }
+    USE MOO, ONLY: Z => I, Z => I   ! { dg-error "conflicts with the rename" }
 END SUBROUTINE Z
 
Index: gcc/testsuite/gfortran.dg/pr89943_2.f90
===================================================================
--- gcc/testsuite/gfortran.dg/pr89943_2.f90	(.../tags/gcc_9_2_0_release)	1970-01-01 01:00:00.000000000 +0100
+++ gcc/testsuite/gfortran.dg/pr89943_2.f90	(.../branches/gcc-9-branch)
@@ -0,0 +1,33 @@
+! { dg-do compile }
+! PR fortran/89943
+! Code contributed by Alberto Luaces  <aluaces at udc dot se>
+module Foo_mod
+
+   implicit none
+
+   interface
+      module function runFoo4C(ndim) bind(C, name="runFoo")
+         use, intrinsic :: iso_c_binding
+         implicit none
+         integer runFoo4c
+         integer(c_int32_t) , intent(in) :: ndim
+      end function runFoo4C
+   end interface
+
+   contains
+
+end module Foo_mod
+
+submodule(Foo_mod) Foo_smod
+
+   contains
+
+      module function runFoo4C(ndim) bind(C, name="runFoo")
+         use, intrinsic :: iso_c_binding
+         implicit none
+         integer runFoo4c
+         integer(c_int32_t) , intent(in) :: ndim
+      end function runFoo4C
+
+end submodule Foo_smod
+
Index: gcc/testsuite/gfortran.dg/warn_unused_dummy_argument_5.f90
===================================================================
--- gcc/testsuite/gfortran.dg/warn_unused_dummy_argument_5.f90	(.../tags/gcc_9_2_0_release)	1970-01-01 01:00:00.000000000 +0100
+++ gcc/testsuite/gfortran.dg/warn_unused_dummy_argument_5.f90	(.../branches/gcc-9-branch)
@@ -0,0 +1,16 @@
+! { dg-do compile }
+! { dg-additional-options "-Wunused-dummy-argument" }
+! PR 91557 - this used to generate a bogus warning
+! Test case by Gerhard Steinmetz
+program p
+   integer :: a, b
+   a = 1
+   call g
+contains
+   subroutine g
+      integer :: x, y
+      call h (x, y)
+      if ( a > 0 )   y = y - 1
+      b = y - x + 1
+   end
+end
Index: gcc/testsuite/gfortran.dg/pr47054_2.f90
===================================================================
--- gcc/testsuite/gfortran.dg/pr47054_2.f90	(.../tags/gcc_9_2_0_release)	1970-01-01 01:00:00.000000000 +0100
+++ gcc/testsuite/gfortran.dg/pr47054_2.f90	(.../branches/gcc-9-branch)
@@ -0,0 +1,41 @@
+! { dg-do compile }
+! { dg-options "-fcray-pointer" }
+! PR fortran/47054
+! Code contributed by Deji Akingunola <deji_aking at yahoo dot ca>
+subroutine host_sub(F_su,F_nk)
+   implicit none
+   
+   integer :: F_nk
+   real,dimension(F_nk) :: F_su
+      integer G_ni, G_nj
+      real*8 G_xg_8, G_yg_8
+      pointer (paxg_8, G_xg_8(G_ni))
+      pointer (payg_8, G_yg_8(G_nj))
+      common / G_p / paxg_8,payg_8
+      common / G / G_ni, G_nj
+   
+   call internal_sub(F_su,F_nk)
+   return
+contains 
+   
+   subroutine internal_sub(F_su,F_nk)
+      implicit none
+      integer G_ni, G_nj
+      real*8 G_xg_8, G_yg_8
+      pointer (paxg_8, G_xg_8(G_ni))
+      pointer (payg_8, G_yg_8(G_nj))
+      common / G_p / paxg_8,payg_8
+      common / G / G_ni, G_nj
+     
+      integer :: F_nk
+      real,dimension(F_nk) :: F_su 
+      integer k,k2
+      
+      k2 = 0
+      do k = 1, F_nk, 2
+         k2 = k2+1
+               F_su(k) = F_su(k) + 1.0
+      enddo
+      return
+   end subroutine internal_sub
+end subroutine host_sub
Index: gcc/testsuite/gfortran.dg/pr91553.f90
===================================================================
--- gcc/testsuite/gfortran.dg/pr91553.f90	(.../tags/gcc_9_2_0_release)	1970-01-01 01:00:00.000000000 +0100
+++ gcc/testsuite/gfortran.dg/pr91553.f90	(.../branches/gcc-9-branch)
@@ -0,0 +1,8 @@
+! { dg-do run }
+! Code contributed by Gerhard Steinmetz
+program p
+   complex z(1)
+   z = (1.0, 2.0) * [real :: (3.0 + 4.0)]
+   if (real(z(1)) /= 7.) stop 1
+   if (aimag(z(1)) /= 14.) stop 2
+end
Index: gcc/testsuite/gfortran.dg/pr91564.f90
===================================================================
--- gcc/testsuite/gfortran.dg/pr91564.f90	(.../tags/gcc_9_2_0_release)	1970-01-01 01:00:00.000000000 +0100
+++ gcc/testsuite/gfortran.dg/pr91564.f90	(.../branches/gcc-9-branch)
@@ -0,0 +1,16 @@
+! { dg-do compile }
+! PR fortran/91564
+! Contributed by Gerhard Steinmetz.
+program p
+   integer i, j
+   call kill (1, 2, 3)        ! { dg-error "shall be an INTENT" }
+   i = 42
+   call bar(i, j)
+end
+
+subroutine bar(n, m)
+   integer, intent(in) :: n
+   integer, intent(inout) :: m
+   call kill (1, 3, n)        ! { dg-error "shall be an INTENT" }
+   call kill (1, 3, m)
+end subroutine bar
Index: gcc/testsuite/gfortran.dg/ISO_Fortran_binding_1.c
===================================================================
--- gcc/testsuite/gfortran.dg/ISO_Fortran_binding_1.c	(.../tags/gcc_9_2_0_release)
+++ gcc/testsuite/gfortran.dg/ISO_Fortran_binding_1.c	(.../branches/gcc-9-branch)
@@ -1,6 +1,7 @@
 /* Test F2008 18.5: ISO_Fortran_binding.h functions.  */
 
 #include "../../../libgfortran/ISO_Fortran_binding.h"
+#include <assert.h>
 #include <stdio.h>
 #include <stdlib.h>
 #include <complex.h>
@@ -33,13 +34,34 @@
       || c_desc->rank != 2)
     return err;
 
-  for (idx[0] = 0; idx[0] < a_desc->dim[0].extent; idx[0]++)
-    for (idx[1] = 0; idx[1] < a_desc->dim[1].extent; idx[1]++)
-      {
-	res_addr = CFI_address (a_desc, idx);
-	*res_addr = *(int*)CFI_address (b_desc, idx)
-		    * *(int*)CFI_address (c_desc, idx);
-      }
+  if (a_desc->attribute == CFI_attribute_other)
+    {
+      assert (a_desc->dim[0].lower_bound == 0);
+      assert (a_desc->dim[1].lower_bound == 0);
+      for (idx[0] = 0; idx[0] < a_desc->dim[0].extent; idx[0]++)
+	for (idx[1] = 0; idx[1] < a_desc->dim[1].extent; idx[1]++)
+	  {
+	    res_addr = CFI_address (a_desc, idx);
+	    *res_addr = *(int*)CFI_address (b_desc, idx)
+			* *(int*)CFI_address (c_desc, idx);
+	  }
+    }
+  else
+    {
+      assert (a_desc->attribute == CFI_attribute_allocatable
+	      || a_desc->attribute == CFI_attribute_pointer);
+      for (idx[0] = a_desc->dim[0].lower_bound;
+	   idx[0] < a_desc->dim[0].extent + a_desc->dim[0].lower_bound;
+	   idx[0]++)
+	for (idx[1] = a_desc->dim[1].lower_bound;
+	     idx[1] < a_desc->dim[1].extent + a_desc->dim[1].lower_bound;
+	     idx[1]++)
+	  {
+	    res_addr = CFI_address (a_desc, idx);
+	    *res_addr = *(int*)CFI_address (b_desc, idx)
+			* *(int*)CFI_address (c_desc, idx);
+	  }
+    }
 
   return 0;
 }
@@ -57,15 +79,16 @@
   CFI_index_t idx[2];
   int *res_addr;
 
+  if (da->attribute == CFI_attribute_other) return err;
   if (CFI_allocate(da, lower, upper, 0)) return err;
+  assert (da->dim[0].lower_bound == lower[0]);
+  assert (da->dim[1].lower_bound == lower[1]);
 
-
-  for (idx[0] = 0; idx[0] < da->dim[0].extent; idx[0]++)
-    for (idx[1] = 0; idx[1] < da->dim[1].extent; idx[1]++)
+  for (idx[0] = lower[0]; idx[0] < da->dim[0].extent + lower[0]; idx[0]++)
+    for (idx[1] = lower[1]; idx[1] < da->dim[1].extent + lower[1]; idx[1]++)
       {
 	res_addr = CFI_address (da, idx);
-	*res_addr = (int)((idx[0] + da->dim[0].lower_bound)
-			  * (idx[1] + da->dim[1].lower_bound));
+	*res_addr = (int)(idx[0] * idx[1]);
       }
 
   return 0;
@@ -86,6 +109,7 @@
 		      CFI_attribute_pointer,
 		      CFI_type_struct,
 		      sizeof(t), 1, extent);
+  assert (desc->dim[0].lower_bound == 0);
   for (idx[0] = 0; idx[0] < extent[0]; idx[0]++)
     {
       res_addr = (t*)CFI_address (desc, idx);
@@ -118,10 +142,11 @@
 			  CFI_type_float, 0, 1, NULL);
       if (ind) return -1.0;
       ind = CFI_section((CFI_cdesc_t *)&section, source, lower, NULL, strides);
+      assert (section.dim[0].lower_bound == lower[0]);
       if (ind) return -2.0;
 
       /* Sum over the section  */
-      for (idx[0] = 0; idx[0] < section.dim[0].extent; idx[0]++)
+      for (idx[0] = lower[0]; idx[0] < section.dim[0].extent + lower[0]; idx[0]++)
         ans += *(float*)CFI_address ((CFI_cdesc_t*)&section, idx);
       return ans;
     }
@@ -138,10 +163,12 @@
       if (ind) return -1.0;
       ind = CFI_section((CFI_cdesc_t *)&section, source,
 			lower, upper, strides);
+      assert (section.rank == 1);
+      assert (section.dim[0].lower_bound == lower[0]);
       if (ind) return -2.0;
 
       /* Sum over the section  */
-      for (idx[0] = 0; idx[0] < section.dim[0].extent; idx[0]++)
+      for (idx[0] = lower[0]; idx[0] < section.dim[0].extent + lower[0]; idx[0]++)
         ans += *(float*)CFI_address ((CFI_cdesc_t*)&section, idx);
       return ans;
     }
@@ -166,6 +193,8 @@
 		      CFI_type_double_Complex, sizeof(double _Complex),
 		      2, extent);
   (void)CFI_select_part(comp_cdesc, source, offsetof(t,y), 0);
+  assert (comp_cdesc->dim[0].lower_bound == 0);
+  assert (comp_cdesc->dim[1].lower_bound == 0);
 
   /* Sum over comp_cdesc[4,:]  */
   size = comp_cdesc->dim[1].extent;
Index: gcc/testsuite/gfortran.dg/pr91727.f90
===================================================================
--- gcc/testsuite/gfortran.dg/pr91727.f90	(.../tags/gcc_9_2_0_release)	1970-01-01 01:00:00.000000000 +0100
+++ gcc/testsuite/gfortran.dg/pr91727.f90	(.../branches/gcc-9-branch)
@@ -0,0 +1,9 @@
+! { dg-do compile }
+! Code contributed by Gerhard Steinmetz.
+program p
+   type t
+      class(*), allocatable :: a
+   end type
+   type(t) :: x
+   allocate (x%a, source=[1]) ! { dg-error "have the same rank as" }
+end
Index: gcc/testsuite/gfortran.dg/pr87993.f90
===================================================================
--- gcc/testsuite/gfortran.dg/pr87993.f90	(.../tags/gcc_9_2_0_release)	1970-01-01 01:00:00.000000000 +0100
+++ gcc/testsuite/gfortran.dg/pr87993.f90	(.../branches/gcc-9-branch)
@@ -0,0 +1,8 @@
+! { dg-do run }
+! Code contributed by Gerhard Steinmetz <gscfq at t-online dot de>
+program p
+   integer, parameter :: a(2) = 1
+   integer, parameter :: b = a%kind
+   if (any(a /= 1)) stop 1
+   if (b /= kind(a)) stop 2
+end
Index: gcc/testsuite/gfortran.dg/do_subscript_6.f90
===================================================================
--- gcc/testsuite/gfortran.dg/do_subscript_6.f90	(.../tags/gcc_9_2_0_release)	1970-01-01 01:00:00.000000000 +0100
+++ gcc/testsuite/gfortran.dg/do_subscript_6.f90	(.../branches/gcc-9-branch)
@@ -0,0 +1,11 @@
+! { dg-do compile }
+! { dg-options "-std=legacy" }
+! PR 91550 - this used to cause an ICE
+! Test case by Gerhard Steinmetz
+program p
+   real :: a(3)
+   integer :: i
+   do i = 1, 3, .1 ! { dg-error "cannot be zero" }
+      a(i) = i
+   end do
+end
Index: gcc/testsuite/gfortran.dg/pr91641.f90
===================================================================
--- gcc/testsuite/gfortran.dg/pr91641.f90	(.../tags/gcc_9_2_0_release)	1970-01-01 01:00:00.000000000 +0100
+++ gcc/testsuite/gfortran.dg/pr91641.f90	(.../branches/gcc-9-branch)
@@ -0,0 +1,7 @@
+! { dg-do compile }
+! PR fortran/91641
+! Code conyributed by Gerhard Steinmetz
+program p
+   real, pointer :: z(:)
+   print *, is_contiguous (null(z))    ! { dg-error "shall be an associated" }
+end
Index: gcc/testsuite/gfortran.dg/pr91471.f90
===================================================================
--- gcc/testsuite/gfortran.dg/pr91471.f90	(.../tags/gcc_9_2_0_release)	1970-01-01 01:00:00.000000000 +0100
+++ gcc/testsuite/gfortran.dg/pr91471.f90	(.../branches/gcc-9-branch)
@@ -0,0 +1,14 @@
+! { dg-do compile }
+! PR fortran/91471
+! Code contributed by Sameeran Joshi <SameeranJayant dot Joshi at amd dot com>
+!
+! This invalid code (x(1) is referenced, but never set) caused an ICE due
+! to hitting a gfc_internal_error() in primary.c (gfc_variable_attr).  The
+! fix is to remove that gfc_internal_error().
+! 
+program dynamic
+   implicit none
+   integer, dimension(:), allocatable :: x
+   allocate(x(1))
+   stop x(1)
+end program dynamic
Index: gcc/testsuite/gfortran.dg/pr78719_2.f90
===================================================================
--- gcc/testsuite/gfortran.dg/pr78719_2.f90	(.../tags/gcc_9_2_0_release)	1970-01-01 01:00:00.000000000 +0100
+++ gcc/testsuite/gfortran.dg/pr78719_2.f90	(.../branches/gcc-9-branch)
@@ -0,0 +1,32 @@
+! { dg-do compile }
+! PR fortran/78719
+! Code contributed by Gerhard Steinmetz 
+program p
+
+   type t
+      integer :: n
+   end type
+
+   real :: g
+
+   abstract interface
+      subroutine h
+      end
+   end interface
+
+   procedure(h), pointer :: s
+
+   s => f
+   call s
+   s => g            ! { dg-error "Invalid procedure pointer" }
+   call s
+
+   contains
+
+      subroutine f
+      end
+
+      subroutine g   ! { dg-error "has an explicit interface" }
+      end
+
+end program p        ! { dg-error "Syntax error" }
Index: gcc/testsuite/gfortran.dg/ISO_Fortran_binding_13.c
===================================================================
--- gcc/testsuite/gfortran.dg/ISO_Fortran_binding_13.c	(.../tags/gcc_9_2_0_release)	1970-01-01 01:00:00.000000000 +0100
+++ gcc/testsuite/gfortran.dg/ISO_Fortran_binding_13.c	(.../branches/gcc-9-branch)
@@ -0,0 +1,12 @@
+/* Test the fix for PR91926.  */
+
+/* Contributed by José Rui Faustino de Sousa  <jrfsousa@hotmail.com> */
+
+#include <stdlib.h>
+
+int ifb_echo(void*);
+
+int ifb_echo(void *this)
+{
+  return this == NULL ? 1 : 2;
+}
Index: gcc/testsuite/gfortran.dg/pr91785.f90
===================================================================
--- gcc/testsuite/gfortran.dg/pr91785.f90	(.../tags/gcc_9_2_0_release)	1970-01-01 01:00:00.000000000 +0100
+++ gcc/testsuite/gfortran.dg/pr91785.f90	(.../branches/gcc-9-branch)
@@ -0,0 +1,8 @@
+! { dg-do compile }
+! PR fortran/91785
+! Code contributed by Gerhard Steinmetz
+program p
+   complex :: a(*)   ! { dg-error "Assumed size array at" }
+   real :: b(2)
+   b = a%im          ! { dg-error "upper bound in the last dimension" }
+end
Index: gcc/testsuite/gfortran.dg/use_15.f90
===================================================================
--- gcc/testsuite/gfortran.dg/use_15.f90	(.../tags/gcc_9_2_0_release)
+++ gcc/testsuite/gfortran.dg/use_15.f90	(.../branches/gcc-9-branch)
@@ -28,8 +28,8 @@
 end subroutine
 
 
-subroutine my_sub3 (a)
-  use test_mod2, my_sub3 => my_sub2  ! { dg-error "is also the name of the current program unit" }
+subroutine my_sub3 (a)              ! { dg-error "\(1\)" }
+  use test_mod2, my_sub3 => my_sub2 ! { dg-error "conflicts with the rename" }
   real a
   print *, a
 end subroutine
Index: gcc/testsuite/gfortran.dg/pr71649.f90
===================================================================
--- gcc/testsuite/gfortran.dg/pr71649.f90	(.../tags/gcc_9_2_0_release)
+++ gcc/testsuite/gfortran.dg/pr71649.f90	(.../branches/gcc-9-branch)
@@ -1,13 +1,13 @@
 ! { dg-do compile }
 ! PR71649 Internal Compiler Error
-SUBROUTINE Compiler_Options ( Options, Version, WriteOpt )
-   USE ISO_FORTRAN_ENV, ONLY : Compiler_Version, Compiler_Options ! { dg-error "already declared" }
+SUBROUTINE Compiler_Options ( Options, Version, WriteOpt )        ! { dg-error "\(1\)" }
+   USE ISO_FORTRAN_ENV, ONLY : Compiler_Version, Compiler_Options ! { dg-error "conflicts with the" }
    IMPLICIT NONE
    CHARACTER (LEN=*), INTENT(OUT) :: Options
    CHARACTER (LEN=*), INTENT(OUT) :: Version
    LOGICAL, INTENT(IN), OPTIONAL  :: WriteOpt
-   Version = Compiler_Version()
-   Options = Compiler_Options() ! { dg-error "Unexpected use of subroutine name" }
+   Version = Compiler_Version()  ! { dg-error "has no IMPLICIT type" }
+   Options = Compiler_Options()  ! { dg-error "Unexpected use of subroutine name" }
    RETURN
 END SUBROUTINE Compiler_Options
 
Index: gcc/testsuite/gfortran.dg/pr89943_1.f90
===================================================================
--- gcc/testsuite/gfortran.dg/pr89943_1.f90	(.../tags/gcc_9_2_0_release)	1970-01-01 01:00:00.000000000 +0100
+++ gcc/testsuite/gfortran.dg/pr89943_1.f90	(.../branches/gcc-9-branch)
@@ -0,0 +1,31 @@
+! { dg-do compile }
+! PR fortran/89943
+! Code contributed by Alberto Luaces  <aluaces at udc dot se>
+module Foo_mod
+
+   implicit none
+
+   interface
+      module subroutine runFoo4C(ndim) bind(C, name="runFoo")
+         use, intrinsic :: iso_c_binding
+         implicit none
+         integer(c_int32_t) , intent(in) :: ndim
+      end subroutine runFoo4C
+   end interface
+
+   contains
+
+end module Foo_mod
+
+submodule(Foo_mod) Foo_smod
+
+   contains
+
+      module subroutine runFoo4C(ndim) bind(C, name="runFoo")
+         use, intrinsic :: iso_c_binding
+         implicit none
+         integer(c_int32_t) , intent(in) :: ndim
+      end subroutine runFoo4C
+
+end submodule Foo_smod
+
Index: gcc/testsuite/gfortran.dg/ISO_Fortran_binding_14.f90
===================================================================
--- gcc/testsuite/gfortran.dg/ISO_Fortran_binding_14.f90	(.../tags/gcc_9_2_0_release)	1970-01-01 01:00:00.000000000 +0100
+++ gcc/testsuite/gfortran.dg/ISO_Fortran_binding_14.f90	(.../branches/gcc-9-branch)
@@ -0,0 +1,41 @@
+! { dg-do run }
+!
+! Correct an error in the eveluation of the CFI descriptor attribute for
+! the case where the bind_C formal argument is not an assumed shape array
+! and not allocatable or pointer.
+!
+! Contributed by Gilles Gouaillardet  <gilles@rist.or.jp>
+!
+MODULE FOO
+INTERFACE
+SUBROUTINE dummy(buf) BIND(C, name="sync")
+type(*), dimension(..) :: buf
+END SUBROUTINE
+END INTERFACE
+END MODULE
+
+PROGRAM main
+    USE FOO
+    IMPLICIT NONE
+    integer(8) :: before, after
+
+    INTEGER, parameter :: n = 1
+
+    INTEGER, ALLOCATABLE :: buf(:)
+    INTEGER :: buf2(n)
+    INTEGER :: i
+
+    ALLOCATE(buf(n))
+    before = LOC(buf(1))
+    CALL dummy (buf)
+    after = LOC(buf(1))
+
+    if (before .NE. after) stop 1
+
+    before = LOC(buf2(1))
+    CALL dummy (buf)
+    after = LOC(buf2(1))
+
+    if (before .NE. after) stop 2
+
+END PROGRAM
Index: gcc/testsuite/gfortran.dg/bind_c_array_params_3_aux.c
===================================================================
--- gcc/testsuite/gfortran.dg/bind_c_array_params_3_aux.c	(.../tags/gcc_9_2_0_release)	1970-01-01 01:00:00.000000000 +0100
+++ gcc/testsuite/gfortran.dg/bind_c_array_params_3_aux.c	(.../branches/gcc-9-branch)
@@ -0,0 +1,26 @@
+/* Used by bind_c_array_params_3.f90.  */
+/* PR fortran/92284.  */
+
+#include <assert.h>
+#include <errno.h>
+#include <stdio.h>
+
+#include "../../../libgfortran/ISO_Fortran_binding.h"
+
+void arr_set_c(CFI_cdesc_t*);
+
+void arr_set_c(CFI_cdesc_t *arr){
+  int i, stat, *auxp = NULL;
+  CFI_index_t   lb[] = {1};
+  CFI_index_t   ub[] = {9};
+  
+  assert(arr);
+  assert(arr->rank==1);
+  assert(!arr->base_addr);
+  stat = CFI_allocate(arr, lb, ub, sizeof(int));
+  assert(stat==CFI_SUCCESS);
+  auxp = (int*)arr->base_addr;
+  assert(auxp);
+  for(i=0; i<ub[0]-lb[0]+1; i++) auxp[i]=i;
+  return;
+}
Index: gcc/testsuite/gfortran.dg/pr91568.f
===================================================================
--- gcc/testsuite/gfortran.dg/pr91568.f	(.../tags/gcc_9_2_0_release)	1970-01-01 01:00:00.000000000 +0100
+++ gcc/testsuite/gfortran.dg/pr91568.f	(.../branches/gcc-9-branch)
@@ -0,0 +1,11 @@
+! { dg-do compile }
+! { dg-options "-Ofast" }
+      subroutine h3dall(z,hvec,hder,nterms)
+      complex *16 hvec(0:1),hder(0:1)
+      complex *16 z,zinv,ztmp/1.0/
+      zinv=1.0/z
+      do i=1,nterms
+         ztmp=zinv*i
+         hder(i)=hvec(i-1)-ztmp*hvec(i)
+      enddo
+      end
Index: gcc/testsuite/gfortran.dg/pr47054_1.f90
===================================================================
--- gcc/testsuite/gfortran.dg/pr47054_1.f90	(.../tags/gcc_9_2_0_release)	1970-01-01 01:00:00.000000000 +0100
+++ gcc/testsuite/gfortran.dg/pr47054_1.f90	(.../branches/gcc-9-branch)
@@ -0,0 +1,15 @@
+! { dg-do compile }
+! { dg-options "-fcray-pointer" }
+! PR fortran/47054
+subroutine host_sub
+   implicit none
+   real xg
+   pointer (paxg, xg)
+   call internal_sub
+   contains 
+      subroutine internal_sub
+         implicit none
+         real xg
+         pointer (paxg, xg)
+      end subroutine internal_sub
+end subroutine host_sub
Index: gcc/testsuite/gfortran.dg/pr91649.f90
===================================================================
--- gcc/testsuite/gfortran.dg/pr91649.f90	(.../tags/gcc_9_2_0_release)	1970-01-01 01:00:00.000000000 +0100
+++ gcc/testsuite/gfortran.dg/pr91649.f90	(.../branches/gcc-9-branch)
@@ -0,0 +1,23 @@
+! { dg-do compile }
+! PR fortran/91649
+! Code originally contributed by Gerhard Steinmetz
+subroutine p
+   logical :: back = .true.
+   integer :: x(1) = findloc([1, 2, 1], '1', back=back) ! { dg-error "must be in type conformance" }
+   print *, x
+end
+
+subroutine q
+   type t
+   end type
+   logical :: back = .false.
+   integer :: x(1) = findloc([1, 2, 1], t(), back=back) ! { dg-error "must be of intrinsic type" }
+   print *, x
+end
+
+subroutine s
+   character(4) :: c = '1234'
+   integer :: x(1) = findloc([1, 2, 1], c, back=.true.) ! { dg-error "must be in type conformance" }
+   print *, x
+end
+
Index: gcc/testsuite/gfortran.dg/pr91552.f90
===================================================================
--- gcc/testsuite/gfortran.dg/pr91552.f90	(.../tags/gcc_9_2_0_release)	1970-01-01 01:00:00.000000000 +0100
+++ gcc/testsuite/gfortran.dg/pr91552.f90	(.../branches/gcc-9-branch)
@@ -0,0 +1,10 @@
+! { dg-do run }
+! PR fortran/91552
+! Code contributed by Gerhard Steinmetz.
+program p
+   real :: y(3), z(4)
+   y = 2.0 * [real :: 1, [2], 3]
+   z = 2.0 * [real :: 1, [2, [4]], 3]
+   if (any(y /= [2., 4., 6.])) stop 1
+   if (any(z /= [2., 4., 8., 6.])) stop 2
+end
Index: gcc/testsuite/gfortran.dg/pr91715.f90
===================================================================
--- gcc/testsuite/gfortran.dg/pr91715.f90	(.../tags/gcc_9_2_0_release)	1970-01-01 01:00:00.000000000 +0100
+++ gcc/testsuite/gfortran.dg/pr91715.f90	(.../branches/gcc-9-branch)
@@ -0,0 +1,5 @@
+! { dg-do compile }
+! PR fortran/91715
+! Code contributed Gerhard Steinmetz
+character(1function f()  ! { dg-error "Syntax error in CHARACTER" }
+end
Index: gcc/testsuite/gfortran.dg/char_result_19.f90
===================================================================
--- gcc/testsuite/gfortran.dg/char_result_19.f90	(.../tags/gcc_9_2_0_release)	1970-01-01 01:00:00.000000000 +0100
+++ gcc/testsuite/gfortran.dg/char_result_19.f90	(.../branches/gcc-9-branch)
@@ -0,0 +1,24 @@
+! { dg-do preprocess }
+! { dg-additional-options "-cpp" }
+!
+! Test the fix for PR86248
+!
+! Contributed by Bill Long  <longb@cray.com>
+!
+program test
+  use test_module
+  implicit none
+  integer :: i
+  character(:), allocatable :: chr
+  do i = 0, 2
+    chr = func_1 (i)
+    select case (i)
+      case (0)
+        if (chr .ne. 'el0') stop i
+      case (1)
+        if (chr .ne. 'el11') stop i
+      case (2)
+        if (chr .ne. 'el2') stop i
+    end select
+  end do
+end program test
Index: gcc/testsuite/gfortran.dg/allocated_3.f90
===================================================================
--- gcc/testsuite/gfortran.dg/allocated_3.f90	(.../tags/gcc_9_2_0_release)	1970-01-01 01:00:00.000000000 +0100
+++ gcc/testsuite/gfortran.dg/allocated_3.f90	(.../branches/gcc-9-branch)
@@ -0,0 +1,6 @@
+! { dg-do compile }
+! PR fortran/91551
+! Contributed by Gerhard Steinmetz
+program p
+   if (allocated()) stop 1 ! { dg-error "requires an array or scalar allocatable" }
+end
Index: gcc/testsuite/gfortran.dg/function_kinds_5.f90
===================================================================
--- gcc/testsuite/gfortran.dg/function_kinds_5.f90	(.../tags/gcc_9_2_0_release)
+++ gcc/testsuite/gfortran.dg/function_kinds_5.f90	(.../branches/gcc-9-branch)
@@ -8,3 +8,4 @@
 real (bad_kind(0d0)) function foo () ! { dg-error "must be an intrinsic function" }
   foo = real (kind (foo))
 end function
+! { dg-prune-output "Bad kind expression for function" }
Index: gcc/testsuite/gfortran.dg/pr88072.f90
===================================================================
--- gcc/testsuite/gfortran.dg/pr88072.f90	(.../tags/gcc_9_2_0_release)	1970-01-01 01:00:00.000000000 +0100
+++ gcc/testsuite/gfortran.dg/pr88072.f90	(.../branches/gcc-9-branch)
@@ -0,0 +1,30 @@
+! { dg-do compile }
+! PR fortran/88072
+! Original code contributed by Andrew Wood <andrew at fluidgravity dot co.uk>
+module m1
+
+   implicit none
+
+   type, abstract, public :: t1
+      integer, dimension(:), allocatable :: i
+      contains
+         procedure(f1), deferred :: f
+   end type t1
+
+   type, extends(t1), public :: t2 ! { dg-error "must be ABSTRACT because" }
+      contains
+         procedure :: f => f2    ! { dg-error "mismatch for the overriding" }
+   end type t2
+
+   abstract interface
+      function f1(this)          ! { dg-error "must be dummy, allocatable or" }
+         import
+         class(t1) :: this
+         class(t1) :: f1
+      end function f1
+   end interface
+   contains
+      type(t2) function f2(this)
+         class(t2) :: this
+      end function f2
+end module m1
Index: gcc/testsuite/gfortran.dg/do_subscript_5.f90
===================================================================
--- gcc/testsuite/gfortran.dg/do_subscript_5.f90	(.../tags/gcc_9_2_0_release)	1970-01-01 01:00:00.000000000 +0100
+++ gcc/testsuite/gfortran.dg/do_subscript_5.f90	(.../branches/gcc-9-branch)
@@ -0,0 +1,20 @@
+! { dg-do compile }
+! { dg-additional-options "-Wdo-subscript" }
+! PR 90563 - this used to be rejected, wrongly
+! Original test case by Tobias Neumann
+program test
+      implicit none
+      integer, parameter :: swap(4) = [2,1,3,4]
+      real :: p(20)
+      integer :: j
+
+      p = 0.0
+
+      ! The following warnings are actually bogus, but we are not yet
+      ! clever enough to suppress them.
+      do j=1,6 ! { dg-warning "out of bounds" }
+          if (j<5) then
+              p(j) = p(swap(j)) ! { dg-warning "out of bounds" }
+          endif
+      enddo
+end program
Index: gcc/testsuite/gfortran.dg/pr91660_2.f90
===================================================================
--- gcc/testsuite/gfortran.dg/pr91660_2.f90	(.../tags/gcc_9_2_0_release)	1970-01-01 01:00:00.000000000 +0100
+++ gcc/testsuite/gfortran.dg/pr91660_2.f90	(.../branches/gcc-9-branch)
@@ -0,0 +1,9 @@
+! { dg-do compile }
+! PR fortran/91660
+program foo
+   type(doubleprecision :: x   ! { dg-error "Malformed type-spec" }
+   type(double precision :: y  ! { dg-error "Malformed type-spec" }
+   type(character(len=3) :: a  ! { dg-error "Malformed type-spec" }
+   type(doublecomplex :: b     ! { dg-error "Malformed type-spec" }
+   type(double complex :: c    ! { dg-error "Malformed type-spec" }
+end program foo
Index: gcc/testsuite/gfortran.dg/pr78719_1.f90
===================================================================
--- gcc/testsuite/gfortran.dg/pr78719_1.f90	(.../tags/gcc_9_2_0_release)	1970-01-01 01:00:00.000000000 +0100
+++ gcc/testsuite/gfortran.dg/pr78719_1.f90	(.../branches/gcc-9-branch)
@@ -0,0 +1,29 @@
+! { dg-do run }
+! PR fortran/78719
+! Code contributed by Gerhard Steinmetz 
+program p
+
+   type t
+      integer :: n
+   end type
+
+   abstract interface
+      subroutine h
+      end
+   end interface
+
+   procedure(h), pointer :: s
+
+   s => f
+   call s
+   s => g
+   call s
+
+   contains
+
+      subroutine f
+      end
+
+      subroutine g
+      end
+end program p
Index: gcc/testsuite/gfortran.dg/pr78739.f90
===================================================================
--- gcc/testsuite/gfortran.dg/pr78739.f90	(.../tags/gcc_9_2_0_release)	1970-01-01 01:00:00.000000000 +0100
+++ gcc/testsuite/gfortran.dg/pr78739.f90	(.../branches/gcc-9-branch)
@@ -0,0 +1,15 @@
+! { dg-do compile }
+! { dg-options "-w" }
+! PR fortran/78739
+! Code contributed Gerhard Steinmetz
+function f(n)
+   f() = n    ! { dg-error "conflicts with function name" }
+end
+
+function g()
+   g(x) = x   ! { dg-error "conflicts with function name" }
+end
+
+function a()  ! This should cause an error, but cannot be easily detected!
+   a() = x
+end
Index: gcc/testsuite/gfortran.dg/pr89647.f90
===================================================================
--- gcc/testsuite/gfortran.dg/pr89647.f90	(.../tags/gcc_9_2_0_release)	1970-01-01 01:00:00.000000000 +0100
+++ gcc/testsuite/gfortran.dg/pr89647.f90	(.../branches/gcc-9-branch)
@@ -0,0 +1,33 @@
+! { dg-do compile }
+! Code contributed by Ian Harvey  <ian_harvey at bigpond dot com>
+  MODULE m1
+    IMPLICIT NONE
+    PUBLIC :: False
+    PUBLIC :: True
+  CONTAINS
+    FUNCTION False() RESULT(b)
+      LOGICAL :: b
+      b = .FALSE.
+    END FUNCTION False
+    
+    FUNCTION True() RESULT(b)
+      LOGICAL :: b
+      b = .TRUE.
+    END FUNCTION True
+  END MODULE m1
+
+  MODULE m2
+    USE m1
+    IMPLICIT NONE
+    TYPE, ABSTRACT :: t_parent
+    CONTAINS
+      PROCEDURE(False), DEFERRED, NOPASS :: Binding
+    END TYPE t_parent
+  CONTAINS
+    SUBROUTINE s
+      TYPE, EXTENDS(t_parent) :: t_extension
+      CONTAINS
+        PROCEDURE, NOPASS :: Binding => True
+      END TYPE t_extension
+    END SUBROUTINE s
+  END MODULE m2
